%VG21 uloha 5 (GPS - oskulacn elementy drhy druzice)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky
% cla;
% clf;

tic;%stopky

ro=180/pi;
GM = 3.986004418e14; %m^3/s^2


%----------------------------
fid = 1;
 fid = fopen('vg21_u05.txt','w'); %vytvoreni *.txt souboru pro vystup
%----------------------------
data_51480; %nacten vstupnch dat (cas a poloha druzice)
%----------------------------



%---------------------------------------------------------------------------------
% 5.1 - vpocet pribliznch hodnot oskulacnch elementu (prevzato z GA12.2)
%---------------------------------------------------------------------------------
zal = data;


%      MJD            Datum      UTC [h m s]         x              y              z [m]     dx/dt          dy/dt          dz/dt [m/s]
%      1            2  3   4     5 6  7              8              9             10         11             12             13
%  52276.21859954    2  1 2002    5 14 47.000   3184462.572   -3628057.472    4740035.177  -3161.527149    4382.082026    5470.210227 
%          1      2 3 4 5 6   7  8 9 10   11      12   13
data = [data(1,2) 0 0 0 0 0 data(1,3:6) (data(2,4:6) - data(1,4:6))/(data(2,3) - data(1,3))];

    ii=1;
%    datum = data(ii,2:4);
    cas = data(ii,7); %[sec]
%    fprintf(fid,'epocha: %.f (%02.f.%02.f.%.f  %2.f:%02.f:%02.f)\n',ii,datum,c2dms(cas/3600));
    Vec_r = data(ii,8:10);
    Vec_rt = data(ii,11:13);
    
    r = (Vec_r * Vec_r')^0.5; %dlka pruvodice r
    V = (Vec_rt * Vec_rt')^0.5; %rychlost druzice V
    Vec_c = vec_soucin(Vec_r,Vec_rt); %Vec hybnosti c
    c = norm(Vec_c); %hybnost  <(Vec_c * Vec_c')^0.5>

    %hlavn poloosa a z integrli ziv sly
    a = 1/(2 / r - V^2 / GM);
%    fprintf(fid,'             hlavn poloosa a = %.3f m\n',a);
    
    %excentricita e z vrazu pro parametr elipsy
    e = (1 - c^2 / (GM * a))^0.5;
%    fprintf(fid,'               excentricita e = %.9f\n',e);
    
    %prav anomlie
    v = acos( ((a*(1-e^2)) / (r*e)) - 1/e );
    
    pom = Vec_r * Vec_rt';
    
    if(pom > 0) %osetreni kvadrantu
        v = v;
    elseif(pom < 0)
        v = 2*pi - v;
    elseif((pom == 0) & (r <= a))
        v = 0;
    elseif((pom == 0) & (r > a))
        v = pi;
    end
    
    E = 2 * atan( ( ((1-e)/(1+e))^0.5 ) * tan(v/2) );%excentrick anomlie
    M = E - e * sin(E);%stredn anomlie v case T
    n = (GM / a^3)^0.5; %stredn denn pohyb
    T = cas;
%   M = n*(T-T0);    
    T0 = T - M/n;%cas pruchodu pericentrem
%    fprintf(fid,'  cas pruchodu pericentrem T0 = %2.f:%02.f:%03.1f\n',c2dms(T0/3600));
%    fprintf(fid,'           stredn anomlie M = %3.f%02.f''%05.2f''''\n',c2dms(ro*M));
    
    W = atan2(Vec_c(1),-Vec_c(2));%rektanscenze vystupniho uzlu
    if(W < 0)
        W = W + 2*pi;
    end
%    fprintf(fid,'rektascenze vstupnho uzlu W = %3.f%02.f''%05.2f''''\n',c2dms(ro*W));

    i = acos(Vec_c(3)/c);%sklon drhy
%    fprintf(fid,'         sklon roviny drhy i = %3.f%02.f''%05.2f''''\n',c2dms(ro*i));
    
    Vec_e3 = [0 0 1];
    
    Vec_s = vec_soucin(Vec_e3,Vec_c);
    s = norm(Vec_s);
    
    pom = acos((Vec_s * Vec_r') / (s * r));
    
    if(Vec_r(3) < 0)
        pom = -pom;
    end
    
    w = pom - v;%vzdlenost pericentra
    
    if(w < 0)
        w = w + 2*pi;
    end
    
%    fprintf(fid,'        argument pericentra w = %3.f%02.f''%05.2f''''\n',c2dms(ro*w));
    
    
%    fprintf(fid,'\n----------------------------------------------------\n');
    
        
    
%---------------------------------------------------------------------------------
% 5.2 - Vpocet presnch hodnot
%---------------------------------------------------------------------------------
data = zal;


[m,n] = size(data);
do = m - 1;

oskul = [];

for ii=1:do; %EEE


for j=1:10 %___

cas1 = data(ii,3);
cas2 = data(ii+1,3);


A = [
    evra(cas1,a,e,T0,W,i,w)
    evra(cas2,a,e,T0,W,i,w)
];

l = [
    data(ii,4:6)' - xyz_druzice(cas1,a,e,T0,W,i,w)
    data(ii+1,4:6)' - xyz_druzice(cas2,a,e,T0,W,i,w)
];


dx = inv(A) * l;


W = W + dx(1);
i = i + dx(2);
w = w + dx(3);
a = a + dx(4);
e = e + dx(5);
T0 = T0 + dx(6);

end %___


% ulozen vsledku

    if(W < 0)
        W = W + 2*pi;
    end

    if(w < 0)
        w = w + 2*pi;
    end    

oskul(ii,:) = [W , i , w , a , e , T0];


end %EEE







%plot3(data(:,4),data(:,5),data(:,6)); %drha druzice v prubehu dne


[den] = mjd2civil(data(1,2));
fprintf(fid,' poloha a oskulacn elementy druzice PRN1 v prubehu dne %.f.%.f.%.f\n\n',den(3),den(2),den(1));

fprintf(fid,'      cas           X [m]           Y [m]           Z [m]            W                     i                  w               a [m]           e         T0 [sec]\n');
fprintf(fid,'----------------------------------------------------------------------------------------------------------------------------------------------------------------\n');


for i=1:do
    fprintf(fid,'   %2.f:%02.f:%02.f %15.3f %15.3f %15.3f     %3.f%02.f''%06.3f''''    %3.f%02.f''%06.3f''''    %3.f%02.f''%06.3f''''    %.3f    %.9f    %.3f\n',c2dms(data(i,3)/3600),data(i,4:6),c2dms(ro*oskul(i,1)),c2dms(ro*oskul(i,2)),c2dms(ro*oskul(i,3)),oskul(i,4:6));
end

    fprintf(fid,'   %2.f:%02.f:%02.f %15.3f %15.3f %15.3f \n',c2dms(data(i+1,3)/3600),data(i+1,4:6));


%GRAFY

ep = [0:24/do:24-24/do];
xi = [0:0.1:24];



clf;%smazat graf
cla;%smazat osy
hold on;
xlim([0,24]);
set(gca,'XTick',0:3:24);
%set(gca,'XTickLabel',{'0','30','60','90','120','150','180','210',''});
title('casov zmena rektascenze vstupnho uzlu \Omega');
xlabel('cas [hod]');
ylabel('rektascenze vstupnho uzlu \Omega []');
y = ro*oskul(:,1); 
yi = interp1(ep,y,xi,'spline'); 
plot(xi,yi);
print -f1 -dpng 'vg21_u05.1(W).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
xlim([0,24]);
set(gca,'XTick',0:3:24);
title('casov zmena sklonu roviny drhy \iti');
xlabel('cas [hod]');
ylabel('sklon roviny drhy \iti\rm []');
y = ro*oskul(:,2); 
yi = interp1(ep,y,xi,'spline'); 
plot(xi,yi);
print -f1 -dpng 'vg21_u05.2(i).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
xlim([0,24]);
set(gca,'XTick',0:3:24);
title('casov zmena argumentu perigea \omega');
xlabel('cas [hod]');
ylabel('argument perigea \omega []');
y = ro*oskul(:,3); 
yi = interp1(ep,y,xi,'spline'); 
plot(xi,yi);
print -f1 -dpng 'vg21_u05.3(w).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
xlim([0,24]);
set(gca,'XTick',0:3:24);
title('casov zmena hlavn poloosy \ita');
xlabel('cas [hod]');
ylabel('hlavn poloosa \ita\rm [m]');
y = oskul(:,4); 
yi = interp1(ep,y,xi,'spline'); 
plot(xi,yi);
print -f1 -dpng 'vg21_u05.4(a).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
xlim([0,24]);
set(gca,'XTick',0:3:24);
title('casov zmena excentricity \ite');
xlabel('cas [hod]');
ylabel('excentricita \ite');
y = oskul(:,5); 
yi = interp1(ep,y,xi,'spline'); 
plot(xi,yi);
print -f1 -dpng 'vg21_u05.5(e).png'; %automaticky export do *.png
hold off;

clf;%smazat graf
cla;%smazat osy
hold on;
xlim([0,24]);
set(gca,'XTick',0:3:24);
title('casov zmena casu pruchodu pericentrem \itT_{0}');
xlabel('cas [hod]');
ylabel('cas pruchodu pericentrem \itT_{0}\rm [sec]');
y = oskul(:,6);
yi = interp1(ep,y,xi,'spline'); 
plot(xi,yi);
print -f1 -dpng 'vg21_u05.6(T0).png'; %automaticky export do *.png
hold off;


fclose(fid);
fprintf('\n\nCseln vsledky jsou ulozeny v souboru "vg21_u05.txt",\ngrafy v souborech "vg21_u05.?(??).png" v pracovnm adresri\n\n');
 
fprintf(1,'\n\ncelkov cas vpoctu a exportu %.3f sec (vetsinu casu zabere export obrzku)\n',toc);